#ifndef DEFINES_H
#define DEFINES_H

#define CW                       0x0001
#define CH                       0x0002
#define QUIT_GAME                0x0010
#define GAME_OVER                0x0020

#define STR                      1024
#define SIM_SIZE                 ((2 + (SUB_LINES / 4)) * SHIP_SIZE)
#define SUB_LINES                10
#define SHIP_SIZE 					40
#define MINE_SIZE                4
#define TICKS                    100
#define FIRE_DELAY               (TICKS + TICKS / 2)
#define TIME_RELOAD              (FIRE_DELAY * 2)
#define MAX_AMMO                 5
#define MAX_SUB_POINTS           50
#define MAX_MINES 					300
#define MINE_SPEED               (TICKS * 50)
#define LIFE                     3
#define SUB_DEATH                (TICKS / 2)
#define BORDER                   SCALE_I2I (SHIP_SIZE/5)

#define SET(x,f)                 ((x)|=(f))
#define GET(x,f)                 ((x)&(f))
#define CLEAR(x,f)               ((x)&= ~(f))

#define WHITE                    makecol (255, 255, 255)
#define BLACK                    makecol (0, 0, 0)
#define YELLOW                   makecol (255, 255, 0)
#define RED                      makecol (255, 0, 0)

#define SCALE_I2I(integer)       (F2I (SCALE_I2F((integer))))
#define SCALE_I2F(integer)       ((integer) * scale)
#define SCALE_F2F(fixed)         (fmul ((fixed), scale))
#define SCALE_F2I(fixed)         (F2I (SCALE_F2F((fixed))))

#define CB                       create_bitmap
#define MAKE_SHIP(color)         floodfill (ship, ship->w / 2, ship->h - 1, (color))
#define SHOW_OUT(text)           textout_centre (screen, font, get_config_text ((text)), \
                                 SCREEN_W/2, SCREEN_H/2, RED); rest (4000);

#define I2F                      itofix
#define F2I                      fixtoi

#define EN_F                     enemy[f]
#define MI_F                     mines[f]

typedef struct t_enemy           ENEMY;
typedef struct t_mine            MINE;

struct t_mine
{
   char  used;
   fixed x, y, speed;
};

struct t_enemy
{
   char  used;
   int   mines, points, time;
   fixed speed, pos;
   BITMAP *bmp;
};

#ifdef GLOBALS

int      flag, w, h, movx, score, level, life, draw_table;
BITMAP   *back, *ship, *sub, *mine, *load, *table;
fixed    scale, posx, deltax, lowx, highx;

int      fire[2], ammo[2];
int      num_subs;

ENEMY    enemy[SUB_LINES];
MINE     mines[MAX_MINES];

volatile int   tick, recharge, delay[2], reload[2];

#else

extern   int      flag, w, h, movx, score, level, life, draw_table;
extern   BITMAP   *back, *ship, *sub, *mine, *load, *table;
extern   fixed    scale, posx, deltax, lowx, highx;

extern   int      fire[2], ammo[2];
extern   int      num_subs;

extern   ENEMY    enemy[SUB_LINES];
extern   MINE     mines[MAX_MINES];

extern   volatile int   tick, recharge, delay[2], reload[2];

#endif

#endif
